Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4647)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4648)
@@ -8187,33 +7905,37 @@
 !
 !--                Particle reflection
-                   move_also_north(nr_move_north)%y       =                    &
-                      -move_also_north(nr_move_north)%y
-                   move_also_north(nr_move_north)%speed_y =                    &
-                      -move_also_north(nr_move_north)%speed_y
+                   move_also_north(nr_move_north)%y       = -move_also_north(nr_move_north)%y
+                   move_also_north(nr_move_north)%speed_y = -move_also_north(nr_move_north)%speed_y
 
                 ENDIF
+
              ENDIF
+
           ELSE
+
              IF ( .NOT. child_domain )  THEN
                 WRITE(0,'(a,8i7)') 'particle out of range ',myid,ip,jp,kp,nxl,nxr,nys,nyn
+
              ENDIF
+
           ENDIF
+
        ENDIF
+
     ENDDO
 
  END SUBROUTINE lpm_add_particles_to_gridcell
 #endif
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> If a particle moves from one grid cell to another (on the current 
-!> processor!), this subroutine moves the corresponding element from the
-!> particle array of the old grid cell to the particle array of the new grid 
-!> cell.
-!------------------------------------------------------------------------------!
+!> If a particle moves from one grid cell to another (on the current processor!), this subroutine
+!> moves the corresponding element from the particle array of the old grid cell to the particle
+!> array of the new grid cell.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_move_particle
- 
+
     INTEGER(iwp)        ::  i           !< grid index (x) of particle position
     INTEGER(iwp)        ::  ip          !< index variable along x
@@ -8243,12 +7965,12 @@
                 k = kp
 !
-!--             Find correct vertical particle grid box (necessary in case of grid stretching)
-!--             Due to the CFL limitations only the neighbouring grid boxes are considered. 
+!--             Find correct vertical particle grid box (necessary in case of grid stretching).
+!--             Due to the CFL limitations only the neighbouring grid boxes are considered.
                 IF( zw(k)   < particles_before_move(n)%z ) k = k + 1
-                IF( zw(k-1) > particles_before_move(n)%z ) k = k - 1 
-
-!--             For lpm_exchange_horiz to work properly particles need to be moved to the outermost gridboxes
-!--             of the respective processor. If the particle index is inside the processor the following lines
-!--             will not change the index
+                IF( zw(k-1) > particles_before_move(n)%z ) k = k - 1
+
+!--             For lpm_exchange_horiz to work properly particles need to be moved to the outermost
+!--             gridboxes of the respective processor. If the particle index is inside the processor
+!--             the following lines will not change the index.
                 i = MIN ( i , nxr )
                 i = MAX ( i , nxl )
@@ -8263,12 +7985,11 @@
                 IF ( i /= ip  .OR.  j /= jp  .OR.  k /= kp )  THEN
 !!
-!--                If the particle stays on the same processor, the particle
-!--                will be added to the particle array of the new processor.
+!--                If the particle stays on the same processor, the particle will be added to the
+!--                particle array of the new processor.
                    number_of_particles = prt_count(k,j,i)
                    particles => grid_particles(k,j,i)%particles(1:number_of_particles)
 
                    pindex = prt_count(k,j,i)+1
-                   IF (  pindex > SIZE(grid_particles(k,j,i)%particles)  )     &
-                   THEN
+                   IF (  pindex > SIZE( grid_particles(k,j,i)%particles )  )  THEN
                       CALL realloc_particles_array( i, j, k )
                    ENDIF
@@ -8290,13 +8011,13 @@
 
  END SUBROUTINE lpm_move_particle
- 
-
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Check CFL-criterion for each particle. If one particle violated the 
-!> criterion the particle will be deleted and a warning message is given.
-!------------------------------------------------------------------------------!
- SUBROUTINE lpm_check_cfl  
+!> Check CFL-criterion for each particle. If one particle violated the criterion the particle will
+!> be deleted and a warning message is given.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE lpm_check_cfl
 
     IMPLICIT NONE
@@ -8312,20 +8033,20 @@
              number_of_particles = prt_count(k,j,i)
              IF ( number_of_particles <= 0 )  CYCLE
-             particles => grid_particles(k,j,i)%particles(1:number_of_particles)         
+             particles => grid_particles(k,j,i)%particles(1:number_of_particles)
              DO  n = 1, number_of_particles
 !
-!--             Note, check for CFL does not work at first particle timestep 
-!--             when both, age and age_m are zero. 
+!--             Note, check for CFL does not work at first particle timestep when both, age and
+!--             age_m are zero.
                 IF ( particles(n)%age - particles(n)%age_m > 0.0_wp )  THEN
-                   IF( ABS( particles(n)%speed_x ) >                           &
-                      ( dx / ( particles(n)%age - particles(n)%age_m) )  .OR.  &
-                       ABS( particles(n)%speed_y ) >                           & 
-                      ( dy / ( particles(n)%age - particles(n)%age_m) )  .OR.  &
-                       ABS( particles(n)%speed_z ) >                           &
-                      ( ( zw(k)-zw(k-1) )                                      &
-                      / ( particles(n)%age - particles(n)%age_m) ) )  THEN
-                      WRITE( message_string, * )                               &
-                      'Particle violated CFL-criterion: &particle with id ',   &
-                      particles(n)%id, ' will be deleted!'   
+                   IF( ABS( particles(n)%speed_x ) >                                               &
+                       ( dx / ( particles(n)%age - particles(n)%age_m) )  .OR.                     &
+                       ABS( particles(n)%speed_y ) >                                               &
+                       ( dy / ( particles(n)%age - particles(n)%age_m) )  .OR.                     &
+                       ABS( particles(n)%speed_z ) >                                               &
+                       ( ( zw(k)-zw(k-1) ) / ( particles(n)%age - particles(n)%age_m) ) )          &
+                   THEN
+                      WRITE( message_string, * )                                                   &
+                         'Particle violated CFL-criterion: &particle with id ', particles(n)%id,   &
+                         ' will be deleted!'
                       CALL message( 'lpm_check_cfl', 'PA0475', 0, 1, -1, 6, 0 )
 
@@ -8336,16 +8057,16 @@
           ENDDO
        ENDDO
-    ENDDO   
+    ENDDO
 
  END SUBROUTINE lpm_check_cfl
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> If the allocated memory for the particle array do not suffice to add arriving
-!> particles from neighbour grid cells, this subrouting reallocates the 
-!> particle array to assure enough memory is available. 
-!------------------------------------------------------------------------------!
+!> If the allocated memory for the particle array does not suffice to add arriving particles from
+!> neighbour grid cells, this subrouting reallocates the particle array to assure enough memory is
+!> available.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE realloc_particles_array ( i, j, k, size_in )
 
@@ -8355,12 +8076,12 @@
     INTEGER(iwp), INTENT(IN), OPTIONAL             ::  size_in        !<
 
+    INTEGER(iwp)                                   ::  new_size        !<
     INTEGER(iwp)                                   ::  old_size        !<
-    INTEGER(iwp)                                   ::  new_size        !<
     TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  tmp_particles_d !<
     TYPE(particle_type), DIMENSION(500)            ::  tmp_particles_s !<
 
-    old_size = SIZE(grid_particles(k,j,i)%particles)
-
-    IF ( PRESENT(size_in) )   THEN
+    old_size = SIZE( grid_particles(k,j,i)%particles )
+
+    IF ( PRESENT( size_in) )  THEN
        new_size = size_in
     ELSE
@@ -8397,16 +8118,16 @@
 
     RETURN
-    
+
  END SUBROUTINE realloc_particles_array
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Not needed but allocated space for particles is dealloced. 
-!------------------------------------------------------------------------------!
+!> Not needed but allocated space for particles is dealloced.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE dealloc_particles_array
 
- 
+
     INTEGER(iwp) ::  i               !<
     INTEGER(iwp) ::  j               !<
@@ -8431,14 +8152,14 @@
 !
 !--          Check for large unused memory
-             dealloc = ( ( number_of_particles < 1 .AND.         &
-                           old_size            > 1 )  .OR.       &
-                         ( number_of_particles > 1 .AND.         &
-                           old_size - number_of_particles *                    &
-                              ( 1.0_wp + 0.01_wp * alloc_factor ) > 0.0_wp ) )
+             dealloc = ( ( number_of_particles < 1 .AND. old_size > 1 )  .OR.                      &
+                         ( number_of_particles > 1 .AND.                                           &
+                           old_size - number_of_particles * ( 1.0_wp + 0.01_wp * alloc_factor )    &
+                           > 0.0_wp )                                                              &
+                       )
 
              IF ( dealloc )  THEN
                 IF ( number_of_particles < 1 )  THEN
                    new_size = 1
-                ELSE 
+                ELSE
                    new_size = INT( number_of_particles * ( 1.0_wp + 0.01_wp * alloc_factor ) )
                 ENDIF
@@ -8474,15 +8195,14 @@
     ENDDO
 
- END SUBROUTINE dealloc_particles_array 
- 
- 
-!------------------------------------------------------------------------------!
+ END SUBROUTINE dealloc_particles_array
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! -----------
-!> Routine for the whole processor
-!> Sort all particles into the 8 respective subgrid boxes (in case of trilinear
-!> interpolation method) and free space of particles which has been marked for
-!> deletion.
-!------------------------------------------------------------------------------!
+!> Routine for the whole processor.
+!> Sort all particles into the 8 respective subgrid boxes (in case of trilinear interpolation
+!> method) and free space of particles which has been marked for deletion.
+!--------------------------------------------------------------------------------------------------!
    SUBROUTINE lpm_sort_and_delete
 
@@ -8520,8 +8240,8 @@
                          nn = nn + 1
 !
-!--                      Sorting particles with a binary scheme
+!--                      Sorting particles with a binary scheme.
 !--                      sort_index=111_2=7_10 -> particle at the left,south,bottom subgridbox
 !--                      sort_index=000_2=0_10 -> particle at the right,north,top subgridbox
-!--                      For this the center of the gridbox is calculated
+!--                      For this the center of the gridbox is calculated.
                          i = (particles(n)%x + 0.5_wp * dx) * ddx
                          j = (particles(n)%y + 0.5_wp * dy) * ddy
@@ -8538,6 +8258,6 @@
                    ENDDO
 !
-!--                Delete and resort particles by overwritting and set
-!--                the number_of_particles to the actual value.
+!--                Delete and resort particles by overwritting and set the number_of_particles to
+!--                the actual value.
                    nn = 0
                    DO  is = 0,7
@@ -8557,8 +8277,7 @@
           ENDDO
 
-!--    In case of the simple interpolation method the particles must not
-!--    be sorted in subboxes. Particles marked for deletion however, must be
-!--    deleted and number of particles must be recalculated as it is also
-!--    done for the trilinear particle advection interpolation method.
+!--    In case of the simple interpolation method the particles must not be sorted in subboxes.
+!--    Particles marked for deletion however, must be deleted and number of particles must be
+!--    recalculated as it is also done for the trilinear particle advection interpolation method.
        ELSE
 
@@ -8571,6 +8290,5 @@
                    particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
 !
-!--                Repack particles array, i.e. delete particles and recalculate
-!--                number of particles
+!--                Repack particles array, i.e. delete particles and recalculate number of particles
                    CALL lpm_pack
                    prt_count(kp,jp,ip) = number_of_particles
@@ -8583,10 +8301,10 @@
     END SUBROUTINE lpm_sort_and_delete
 
- 
-!------------------------------------------------------------------------------!
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Move all particles not marked for deletion to lowest indices (packing)
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE lpm_pack
 
@@ -8594,6 +8312,6 @@
        INTEGER(iwp) ::  nn      !<
 !
-!--    Find out elements marked for deletion and move data from highest index
-!--    values to these free indices
+!--    Find out elements marked for deletion and move data from highest index values to these free
+!--    indices
        nn = number_of_particles
 
@@ -8618,18 +8336,17 @@
 
 !
-!--    The number of deleted particles has been determined in routines
-!--    lpm_boundary_conds, lpm_droplet_collision, and lpm_exchange_horiz
+!--    The number of deleted particles has been determined in routines lpm_boundary_conds,
+!--    lpm_droplet_collision, and lpm_exchange_horiz
        number_of_particles = nn
 
-    END SUBROUTINE lpm_pack 
-
-
-!------------------------------------------------------------------------------!
+    END SUBROUTINE lpm_pack
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Sort particles in each sub-grid box into two groups: particles that already
-!> completed the LES timestep, and particles that need further timestepping to
-!> complete the LES timestep. 
-!------------------------------------------------------------------------------!
+!> Sort particles in each sub-grid box into two groups: particles that already completed the LES
+!> timestep, and particles that need further timestepping to complete the LES timestep.
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE lpm_sort_timeloop_done
 
@@ -8661,9 +8378,9 @@
                    end_index   = grid_particles(k,j,i)%end_index(nb)
 !
-!--                Allocate temporary array used for sorting. 
+!--                Allocate temporary array used for sorting.
                    ALLOCATE( sort_particles(start_index:end_index) )
 !
-!--                Determine number of particles already completed the LES 
-!--                timestep, and write them into a temporary array. 
+!--                Determine number of particles already completed the LES timestep, and write them
+!--                into a temporary array.
                    nf = start_index
                    num_finalized = 0
@@ -8676,6 +8393,6 @@
                    ENDDO
 !
-!--                Determine number of particles that not completed the LES 
-!--                timestep, and write them into a temporary array. 
+!--                Determine number of particles that not completed the LES timestep, and write them
+!--                into a temporary array.
                    nnf = nf
                    DO  n = start_index, end_index
@@ -8687,20 +8404,17 @@
 !
 !--                Write back sorted particles
-                   particles(start_index:end_index) =                          &
-                                           sort_particles(start_index:end_index)
-!
-!--                Determine updated start_index, used to masked already 
-!--                completed particles. 
-                   grid_particles(k,j,i)%start_index(nb) =                     &
-                                      grid_particles(k,j,i)%start_index(nb)    &
-                                    + num_finalized
+                   particles(start_index:end_index) = sort_particles(start_index:end_index)
+!
+!--                Determine updated start_index, used to masked already
+!--                completed particles.
+                   grid_particles(k,j,i)%start_index(nb) = grid_particles(k,j,i)%start_index(nb)   &
+                                                           + num_finalized
 !
 !--                Deallocate dummy array
                    DEALLOCATE ( sort_particles )
 !
-!--                Finally, if number of non-completed particles is non zero 
-!--                in any of the sub-boxes, set control flag appropriately. 
-                   IF ( nnf > nf )                                             &
-                      grid_particles(k,j,i)%time_loop_done = .FALSE.
+!--                Finally, if number of non-completed particles is non zero
+!--                in any of the sub-boxes, set control flag appropriately.
+                   IF ( nnf > nf )  grid_particles(k,j,i)%time_loop_done = .FALSE.
 
                 ENDDO
@@ -8709,5 +8423,5 @@
        ENDDO
 
-    END SUBROUTINE lpm_sort_timeloop_done 
+    END SUBROUTINE lpm_sort_timeloop_done
 
 END MODULE lagrangian_particle_model_mod
